import java.util.ArrayList;
import java.util.Collection;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedNativeQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "EMP")
@NamedNativeQuery(name = "nativeSQL", query = "SELECT emp1.emp_id, emp1.name, emp1.manager_id, "
    + "emp1.dept_id, emp1.address_id " + "FROM EMP emp1, EMP emp2 "
    + "WHERE ((emp2.EMP_ID = ?) AND (emp2.EMP_ID = emp1.MANAGER_ID))", resultClass = Professor.class)
public class Professor {
  @Id
  @Column(name = "EMP_ID")
  private int id;

  private String name;

  @OneToOne
  private Address address;

  @ManyToOne
  @JoinColumn(name = "DEPT_ID")
  private Department department;

  @ManyToOne
  @JoinColumn(name = "MANAGER_ID")
  private Professor manager;

  @OneToMany(mappedBy = "manager")
  private Collection<Professor> directs = new ArrayList<Professor>();

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Address getAddress() {
    return address;
  }

  public void setAddress(Address address) {
    this.address = address;
  }

  public Department getDepartment() {
    return department;
  }

  public void setDepartment(Department department) {
    this.department = department;
  }

  public Collection<Professor> getDirects() {
    return directs;
  }

  public void addDirect(Professor employee) {
    if (!getDirects().contains(employee)) {
      getDirects().add(employee);
      if (employee.getManager() != null) {
        employee.getManager().getDirects().remove(employee);
      }
      employee.setManager(this);
    }
  }

  public Professor getManager() {
    return manager;
  }

  public void setManager(Professor manager) {
    this.manager = manager;
  }

  public String toString() {
    return "Professor id: " + getId() + " name: " + getName() + " with MgrId: "
        + (getManager() == null ? null : getManager().getId());
  }
}
